Imports TIS.Imaging
Imports TIS.Imaging.VCDHelpers

Public Class Form1

    Private _GPIn As VCDRangeProperty
    Private _GPInRead As VCDButtonProperty
    Private _GPOut As VCDRangeProperty
    Private _GPIOWrite As VCDButtonProperty


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        If Not IcImagingControl1.DeviceValid Then
            IcImagingControl1.ShowDeviceSettingsDialog()

            If Not IcImagingControl1.DeviceValid Then
                MsgBox("No device was selected.", MsgBoxStyle.Information, "DigitalIO")

                Me.Close()
                Exit Sub
            End If
        End If


        ' VCDvpeB̃NXāAICImagingControl IuWFNg̃vpeBɃANZX܂B
        IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIOIn, _GPIn)
        IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIOOut, _GPOut)
        IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIORead, _GPInRead)
        IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_GPIO, VCDGUIDs.VCDElement_GPIOWrite, _GPIOWrite)



        If Not _GPIn Is Nothing Then

            cmdReadDigitalInput.Enabled = True
            ReadDigitalInput()
        Else
            cmdReadDigitalInput.Enabled = False
        End If


        If Not _GPOut Is Nothing Then
            'fW^o͂̏Ԃ擾܂B
            cmdWriteDigitalOutput.Enabled = True
            chkDigitalOutputState.Enabled = True

            If _GPOut.Value = 1 Then
                chkDigitalOutputState.CheckState = CheckState.Checked
            Else
                chkDigitalOutputState.CheckState = CheckState.Unchecked
            End If
        Else
            cmdWriteDigitalOutput.Enabled = False
            chkDigitalOutputState.Enabled = False
        End If

        ' CuXg[~OJn
        IcImagingControl1.LiveStart()

    End Sub
    
    Private Sub cmdReadDigitalInput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReadDigitalInput.Click
        ReadDigitalInput()
    End Sub

    ''' <summary>
    ''' cmdReadDigitalInput_Click
    '''
    ''' Read the current state of the digital input and set the checkbox
    ''' chkDigitalInputState to this state.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ReadDigitalInput()
        '  JgK[͂ǂݎ܂B
        _GPInRead.Push()

        If _GPIn.Value = 1 Then
            chkDigitalInputState.CheckState = CheckState.Checked
        Else
            chkDigitalInputState.CheckState = CheckState.Unchecked
        End If

    End Sub

    ''' <summary>
    ''' cmdWriteDigitalOutput_Click
    '''
    ''' Set the digital outputs of the video capture device to the state of the
    ''' chkDigitalOutputState check box and write this state to the video capture
    ''' device.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub cmdWriteDigitalOutput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdWriteDigitalOutput.Click
        ' `FbN{bNX̒lJɔf
        If chkDigitalOutputState.CheckState = CheckState.Checked Then
            _GPOut.Value = 1
        Else
            _GPOut.Value = 0
        End If

        ' ݂̃Xe[^XŃXg{o͂s
        _GPInRead.Push()
    End Sub
End Class
